<template>
  <ob-modal
    ref="logchainsModal"
    title="Выберите логцепочку"
    size="extra-large"
    ok-text="Выбрать"
    cancel-text="Закрыть"
    is-show-controls
    data-qa="logcainsModal"
    custom-class="ob-logchains-modal-wrapper"
    @submit="selectLogchain"
    @closed="close"
  >
    <div class="ob-logchain-modal">
      <div class="empty-warning" v-if="!logchainsWithoutErrors.length && logchainsWithErrors.length">
        <div class="empty-warning__icon">
          <i class="icon call-center"></i>
        </div>
        <div class="empty-warning__text">
          <h4>Ой! Возникли сложности при обработке запроса, лучше обратитесь к менеджеру</h4>
          <p>
            Функционал отправки груза находится в стадии бета-тестирования. Что-то могло пойти не так, но мы уже работаем над этим. Попробуйте еще раз, или обратитесь к менеджеру:
          </p>

          <p>
            <span>Телефон</span>: <a :href="`tel:${$options.contacts[platform].linkphone}`">
              {{$options.contacts[platform].phone}}
            </a> с 9:00 до 18:00 пн-пт
            <br />
            <span>Номер вашего заказа: {{ orderNumber }}</span>
          </p>
          
          <p>
            Предложения и пожелания по работе системы вы можете отправить в службу технической поддержки на <a :href="`mailto:${$options.contacts[platform].email}`">{{ $options.contacts[platform].email }}</a>
          </p>
        </div>
      </div>
      <div v-for="card in logchainsWithoutErrors" :key="card.uuid">
        <component
          :is="activeComponent"
          :class="selectedLogchain === card.main_data.uuid ? 'selected' : ''"
          :logchain="card"
          :contractNumber="contractNumber"
          mode="list"
          @click.native="onLogchainSelect(card)"
        />
      </div>
      <div class="logchains-with-errors" v-if="logchainsWithErrors.length && !showErrors" @click="showErrors = !showErrors">
        Показать все логцепочки (ещё {{ logchainsWithErrors.length }})
      </div>
      <template v-if="showErrors">
        <div v-for="card in logchainsWithErrors" :key="card.uuid">
        <component
          :is="activeComponent"
          :class="selectedLogchain === card.main_data.uuid ? 'selected' : ''"
          :logchain="card"
          mode="list"
          :contractNumber="contractNumber"
          @click.native="onLogchainSelect(card)"
          @showErrors="onShowErrors"
        />
      </div>
      </template>
    </div>
  </ob-modal>
</template>

<script>
import { contacts } from "@/resources/contacts";
import { mapGetters } from "vuex";
import ObModal from "common-components/src/obComponents/obModal";
import LogchainCard from "../../components/Order/logchainCard";
import ClicarLogchainCard from "../../components/Order/clicarLogchainCard";
export default {
  name: "orderLogchainList",

  props: {
    logchainsWithoutErrors: {
      type: Array,
      required: true,
    },

    logchainsWithErrors: {
      type: Array,
      required: true,
    },

    resourceClass: {
      type: String,
      default: "FTL",
    },

    orderNumber: {
      type: String,
      required: true,
    },

    contractNumber: {
      type: String,
      required: true
    }
  },

  components: {
    ObModal,
    LogchainCard,
  },

  data() {
    return {
      selectedLogchain: "",
      showErrors: false
    };
  },

  contacts,

  computed: {
    ...mapGetters({
      role: "user/role",
    }),
    activeComponent() {
      let componentsMap = {
        client: LogchainCard,
        clicar: ClicarLogchainCard,
      };
      return componentsMap[this.role];
    },

    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? "oboz"
        : "gruzi";
    }
  },

  methods: {
    onShowErrors($event) {
      this.$emit('showErrors', $event)
    },
    onLogchainSelect(card) {
      this.selectedLogchain = card.main_data.uuid;
    },

    selectLogchain() {
      this.$emit("selectLogchain", this.selectedLogchain);
    },

    open() {
      this.$refs.logchainsModal.open();
    },
    close() {
      this.showErrors = false;
      this.$emit('close');
      this.$refs.logchainsModal.close();
    },
  },
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-logchains-modal-wrapper {
  &.el-dialog.modal-max {
    margin: 0 !important;
    width: 100% !important;
    height: 100% !important;
    max-width: none !important;
    overflow-y: auto;
  }

  .ob-logchain-modal {
    padding: 0 24px;
  }
  .logchain-card {
    position: relative;
    margin-bottom: 20px;
    cursor: pointer;

    &:after {
      content: "";
      width: 100%;
      height: 100%;
      position: absolute;
      left: 0;
      top: 0;
      border: 1px solid transparent;
      border-radius: 4px;
      pointer-events: none;
    }

    &:hover:after {
      border-color: #004bc8;
    }

    &.selected {
      &:after {
        width: calc(100% - 16px);
        border-color: #004bc8;
        border-left-width: 16px;
        box-shadow: inset 0px 4px 12px rgba(0, 75, 200, 0.25);
      }
    }
  }
}

.logchains-with-errors {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 60px;
  background-color: $background-white;
  border-radius: 4px;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
  color: $color-blue-smalt;
  cursor: pointer;
}

.empty-warning {
  display: flex;
  padding: 27px 20px;
  margin-bottom: 20px;
  border-radius: 4px;
  border-left: 6px solid $diamond-orange-yellow;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
}

.empty-warning__icon {
  .icon {
    font-size: 22px;
    color: $diamond-orange-yellow;
  }
}

.modal-body .empty-warning__text {
  padding-left: 22px;

  p {
    color: $gray-slate;
  }

  span {
    color: $color-text-base;
  }

  a {
    text-decoration: none;
    color: $color-blue-smalt;
  }

  h4 {
    @include font-mixin(16px, 20px, 700, $color-text-base);
    margin-bottom: 1em;
  }
}
</style>
